<?php
/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
return [
	'new' => [
		'text' => g_l('modules_banner', '[new]'),
		'icon' => 'fa fa-plus-circle',
	],
	[
		'text' => g_l('modules_banner', '[banner]'),
		'cmd' => 'new_banner',
		'perm' => [we_base_perm::BANNER_NEW],
		'parent' => 'new',
	],
	[
		'text' => g_l('modules_banner', '[bannergroup]'),
		'cmd' => 'new_bannergroup',
		'perm' => [we_base_perm::BANNER_NEW],
		'parent' => 'new',
	],
	'banner' => [
		'text' => g_l('modules_banner', '[banner]'),
		'icon' => 'fa fa-flag-checkered'
	],
	[
		'text' => g_l('modules_banner', '[save]'),
		'parent' => 'banner',
		'cmd' => 'save_banner',
		'perm' => [we_base_perm::BANNER_EDIT],
	],
	[
		'text' => g_l('modules_banner', '[delete]'),
		'parent' => 'banner',
		'cmd' => 'delete_banner',
		'perm' => [we_base_perm::BANNER_DELETE],
	],
	[
		'parent' => 'banner', // separator
	],
	[
		'text' => g_l('modules_banner', '[quit]'),
		'parent' => 'banner',
		'cmd' => 'exit_banner',
	],
	'options' => [
		'text' => g_l('modules_banner', '[options]'),
		'icon' => 'fa fa-cog'
	],
	[
		'text' => g_l('modules_banner', '[defaultbanner]') . '&hellip;',
		'parent' => 'options',
		'cmd' => 'banner_default',
		'perm' => [we_base_perm::BANNER_EDIT],
	],
	[
		'text' => g_l('modules_banner', '[bannercode]') . '&hellip;',
		'parent' => 'options',
		'cmd' => 'banner_code',
		'perm' => [we_base_perm::BANNER_EDIT],
	],
];
