<?php
/**
 * webEdition CMS
 *
 * $Rev: 14637 $
 * $Author: mokraemer $
 * $Date: 2017-12-05 02:10:46 +0100 (Tue, 05 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
$seeMode = !(isset($_SESSION['weS']['we_mode']) && $_SESSION['weS']['we_mode'] == we_base_constants::MODE_NORMAL);
$we_menu = [
	we_base_menu::E_NEW => [// New
		'text' => g_l('menu_global', '[new]'),
		'icon' => 'fa fa-plus-circle',
	],
	'file_new_wedoc0' => [// New > webEdition Document
		'text' => g_l('menu_global', '[webEdition_page]'),
		'parent' => we_base_menu::E_NEW,
		'perm' => [we_base_perm::WORK_DOCUMENT_WEBEDITION_NEW],
	], [// New > webEdition Document > empty page
		'text' => g_l('menu_global', '[empty_page]'),
		'parent' => 'file_new_wedoc0',
		'cmd' => 'new_webEditionPage',
		'perm' => [we_base_perm::WORK_DOCUMENT_NO_DOCTYPE_ALLOWED],
	], [
		'parent' => 'file_new_wedoc0',
		'hide' => !$seeMode,
	],
	'file_new_weobj' => [// New > Object
		'text' => g_l('menu_object', '[object]'),
		'parent' => we_base_menu::E_NEW,
		'perm' => [we_base_perm::OBJECTFILE_NEW],
		'hide' => !we_modules_info::isActive(we_modules_info::OBJECT)
	],
	'file_new_media' => [
		'text' => g_l('menu_global', '[media]'),
		'parent' => we_base_menu::E_NEW,
		'perm' => [we_base_perm::WORK_IMAGE_NEW, we_base_perm::WORK_VIDEO_NEW, we_base_perm::WORK_OTHER_NEW],
	], [// File > Image
		'text' => g_l('menu_global', '[image]'),
		'parent' => 'file_new_media',
		'cmd' => 'new_image',
		'perm' => [we_base_perm::WORK_IMAGE_NEW],
	], [// New > Other > Other (Binary)
		'text' => g_l('menu_global', '[pdf]'),
		'parent' => 'file_new_media',
		'cmd' => 'new_pdf_document',
		'perm' => [we_base_perm::WORK_OTHER_NEW],
	], [// New > Other > Flash
		'text' => g_l('menu_global', '[flash_movie]'),
		'parent' => 'file_new_media',
		'cmd' => 'new_flash_movie',
		'perm' => [we_base_perm::WORK_VIDEO_NEW],
	], [// New Other > video
		'text' => g_l('contentTypes', '[' . we_base_ContentTypes::VIDEO . ']'),
		'parent' => 'file_new_media',
		'cmd' => 'new_video_movie',
		'perm' => [we_base_perm::WORK_VIDEO_NEW],
	], [// New Other > audio
		'text' => g_l('contentTypes', '[' . we_base_ContentTypes::AUDIO . ']'),
		'parent' => 'file_new_media',
		'cmd' => 'new_audio_audio',
		'perm' => [we_base_perm::WORK_OTHER_NEW],
	],
	'file_new_other' => [// New > Other
		'text' => g_l('menu_global', '[other]'),
		'parent' => we_base_menu::E_NEW,
		'perm' => [we_base_perm::WORK_HTML_NEW, we_base_perm::WORK_JS_NEW, we_base_perm::WORK_CSS_NEW, we_base_perm::WORK_TEXT_NEW, we_base_perm::WORK_HTACCESS_NEW, we_base_perm::WORK_OTHER_NEW],
	], [// New > Other > html
		'text' => g_l('menu_global', '[html_page]'),
		'parent' => 'file_new_other',
		'cmd' => 'new_html_page',
		'perm' => [we_base_perm::WORK_HTML_NEW],
	], [// New > Other > Javascript
		'text' => g_l('menu_global', '[javascript]'),
		'parent' => 'file_new_other',
		'cmd' => 'new_javascript',
		'perm' => [we_base_perm::WORK_JS_NEW],
	], [// New > Other > CSS
		'text' => g_l('menu_global', '[css_stylesheet]'),
		'parent' => 'file_new_other',
		'cmd' => 'new_css_stylesheet',
		'perm' => [we_base_perm::WORK_CSS_NEW],
	], [// New > Other > Text
		'text' => g_l('menu_global', '[text_plain]'),
		'parent' => 'file_new_other',
		'cmd' => 'new_text_plain',
		'perm' => [we_base_perm::WORK_TEXT_NEW],
	], [// New > Other > XML
		'text' => g_l('menu_global', '[text_xml]'),
		'parent' => 'file_new_other',
		'cmd' => 'new_text_xml',
		'perm' => [we_base_perm::WORK_TEXT_NEW],
	], [// New > Other > htaccess
		'text' => g_l('menu_global', '[htaccess]'),
		'parent' => 'file_new_other',
		'cmd' => 'new_text_htaccess',
		'perm' => [we_base_perm::WORK_HTACCESS_NEW],
	], [// New > Other > Other (Binary)
		'text' => g_l('menu_global', '[other_files]'),
		'parent' => 'file_new_other',
		'cmd' => 'new_binary_document',
		'perm' => [we_base_perm::WORK_OTHER_NEW],
	], [
		'parent' => we_base_menu::E_NEW,
		'hide' => $seeMode
	],
	'file_new_dir' => [// New > Directory
		'text' => g_l('menu_global', '[directory]'),
		'parent' => we_base_menu::E_NEW,
		'hide' => $seeMode,
		'perm' => [we_base_perm::WORK_DOCUMENT_FOLDER_NEW, we_base_perm::WORK_TEMPLATES_FOLDER_NEW, we_base_perm::OBJECTFILE_NEW_FOLDER, we_base_perm::WORK_COLLECTION_FOLDER_NEW],
	], [// New > Directory > Document
		'text' => g_l('menu_global', '[document_directory]'),
		'parent' => 'file_new_dir',
		'cmd' => 'new_document_folder',
		'perm' => [we_base_perm::WORK_DOCUMENT_FOLDER_NEW],
		'hide' => $seeMode
	], [// New > Directory > Template
		'text' => g_l('menu_global', '[template_directory]'),
		'parent' => 'file_new_dir',
		'cmd' => 'new_template_folder',
		'perm' => [we_base_perm::WORK_TEMPLATES_FOLDER_NEW],
		'hide' => $seeMode
	], [// New > directory > objectfolder
		'text' => g_l('menu_object', '[object_directory]'),
		'parent' => 'file_new_dir',
		'cmd' => 'new_objectfile_nested_folder',
		'perm' => [we_base_perm::OBJECTFILE_NEW_FOLDER],
		'hide' => !we_modules_info::isActive(we_modules_info::OBJECT) || ($_SESSION['weS']['we_mode'] != we_base_constants::MODE_NORMAL)
	], /* [// New > directory > classfolder
	  'text' => g_l('menu_object', '[object_directory]'),
	  'parent' => 'file_new_dir',
	  'cmd' => 'new_object_folder',
	  'perm' => [we_base_perm::OBJECT_NEW],
	  'hide' => !we_modules_info::isActive(we_modules_info::OBJECT) || ($_SESSION['weS']['we_mode'] != we_base_constants::MODE_NORMAL)
	  ], */
	[// New > Directory > Collection
		'text' => g_l('menu_global', '[collection_directory]'),
		'parent' => 'file_new_dir',
		'cmd' => 'new_collection_folder',
		'perm' => [we_base_perm::WORK_COLLECTION_FOLDER_NEW],
		'hide' => $seeMode || !we_modules_info::isActive(we_modules_info::COLLECTION)
	], ['parent' => we_base_menu::E_NEW,
		'perm' => [we_base_perm::OBJECT_NEW, we_base_perm::WORK_TEMPLATE_NEW],
		'hide' => $seeMode
	], [// New > Template
		'text' => g_l('menu_global', '[template]'),
		'parent' => we_base_menu::E_NEW,
		'cmd' => 'new_template',
		'perm' => [we_base_perm::WORK_TEMPLATE_NEW],
		'hide' => $seeMode
	], [// New > Class
		'text' => g_l('menu_object', '[class]'),
		'parent' => we_base_menu::E_NEW,
		'cmd' => 'new_object',
		'perm' => [we_base_perm::OBJECT_NEW],
		'hide' => !we_modules_info::isActive(we_modules_info::OBJECT) || ($_SESSION['weS']['we_mode'] != we_base_constants::MODE_NORMAL)
	], [
		'parent' => we_base_menu::E_NEW,
		'perm' => [we_base_perm::WORK_COLLECTION_NEW],
		'hide' => $seeMode || !we_modules_info::isActive(we_modules_info::COLLECTION)
	], [// File > COLLECTION
		'text' => g_l('menu_global', '[collection]'),
		'parent' => we_base_menu::E_NEW,
		'cmd' => 'new_collection',
		'perm' => [we_base_perm::WORK_COLLECTION_NEW],
		'hide' => !we_modules_info::isActive(we_modules_info::COLLECTION)
	],
	we_base_menu::E_FILE => [// File
		'text' => g_l('menu_global', '[file]'),
		'icon' => 'fa fa-file',
	],
	/* 	$we_menu[1011100]['parent'] = we_base_menu::E_NEW; // separator
	  // New > Wizards
	  'text'=> g_l('menu_global', '[wizards]') . '&hellip;',
	  'parent'=> we_base_menu::E_NEW,

	  // New > Wizard > First Steps Wizard
	  'text'=> g_l('menu_global', '[first_steps_wizard]'),
	  'parent'=> 1011200,
	  'cmd'=> 'openFirstStepsWizardMasterTemplate',
	  'perm'=> [we_base_perm::ADMINISTRATOR],

	  $we_menu[1020000]['parent'] = we_base_menu::E_FILE; // separator
	 */
	'file_open' => [// File > Open
		'text' => g_l('menu_global', '[open]'),
		'parent' => we_base_menu::E_FILE,
		'hide' => !$seeMode,
	], [// File > Open > Document
		'text' => g_l('menu_global', '[open_document]') . '&hellip;',
		'parent' => 'file_open',
		'cmd' => 'open_document',
		'perm' => [we_base_perm::WORK_DOCUMENTS_CAN_SEE],
		'hide' => !$seeMode,
	], [// File > open > Object
		'text' => g_l('menu_object', '[open_object]') . '&hellip;',
		'parent' => 'file_open',
		'cmd' => 'open_objectFile',
		'perm' => [we_base_perm::OBJECTFILES_CAN_SEE],
		'hide' => !$seeMode || !we_modules_info::isActive(we_modules_info::OBJECT)
	], [// File > Open > Collection
		'text' => g_l('menu_global', '[collection]') . '&hellip;',
		'parent' => 1030000,
		'cmd' => 'open_collection',
		'perm' => [we_base_perm::WORK_COLLECTIONS_CAN_SEE],
		'hide' => !$seeMode || !we_modules_info::isActive(we_modules_info::COLLECTION)
	], /* ['parent' => 'file_open',
	  'perm' => [we_base_perm::WORK_TEMPLATES_CAN_SEE, we_base_perm::OBJECTS_CAN_SEE],
	  'hide' => $seeMode
	  ], [// File > Open > Template
	  'text' => g_l('menu_global', '[open_template]') . '&hellip;',
	  'parent' => 'file_open',
	  'cmd' => 'open_template',
	  'perm' => [we_base_perm::WORK_TEMPLATES_CAN_SEE],
	  'hide' => $seeMode
	  ], [// File > Open > Class
	  'text' => g_l('menu_object', '[open_class]') . '&hellip;',
	  'parent' => 'file_open',
	  'cmd' => 'open_object',
	  'perm' => [we_base_perm::OBJECTS_CAN_SEE],
	  'hide' => !we_modules_info::isActive(we_modules_info::OBJECT) || ($_SESSION['weS']['we_mode'] != we_base_constants::MODE_NORMAL)
	  ], */
	'file_delete' => [// File > Delete
		'text' => g_l('menu_global', '[delete]') . ($seeMode ? '&hellip;' : ''),
		'parent' => we_base_menu::E_FILE,
		'cmd' => $seeMode ? 'we_selector_delete' : '',
		'perm' => $seeMode ? [we_base_perm::WORK_DOCUMENT_DELETE] : [we_base_perm::WORK_DOCUMENT_DELETE, we_base_perm::OBJECTFILE_DELETE, we_base_perm::WORK_TEMPLATE_DELETE,
		we_base_perm::OBJECT_DELETE],
	], [// File > Delete > Documents
		'text' => g_l('menu_global', '[documents]'),
		'parent' => 'file_delete',
		'cmd' => 'delete_documents',
		'perm' => [we_base_perm::WORK_DOCUMENT_DELETE],
		'hide' => $seeMode,
	], [// File > Delete > Objects
		'text' => g_l('menu_object', '[objects]'),
		'parent' => 'file_delete',
		'cmd' => 'delete_objectfile',
		'perm' => [we_base_perm::OBJECTFILE_DELETE],
		'hide' => !we_modules_info::isActive(we_modules_info::OBJECT) || ($_SESSION['weS']['we_mode'] != we_base_constants::MODE_NORMAL)
	], [
		'parent' => 'file_delete',
		'perm' => [we_base_perm::WORK_TEMPLATES_CAN_SEE, we_base_perm::OBJECTS_CAN_SEE],
		'hide' => $seeMode
	], [// File > Delete > Templates
		'text' => g_l('menu_global', '[templates]'),
		'parent' => 'file_delete',
		'cmd' => 'delete_templates',
		'perm' => [we_base_perm::WORK_TEMPLATE_DELETE],
		'hide' => $seeMode,
	], [// File > Delete > Classes
		'text' => g_l('menu_object', '[classes]'),
		'parent' => 'file_delete',
		'cmd' => 'delete_object',
		'perm' => [we_base_perm::OBJECT_DELETE],
		'hide' => !we_modules_info::isActive(we_modules_info::OBJECT) || ($_SESSION['weS']['we_mode'] != we_base_constants::MODE_NORMAL)
	], [
		'parent' => 'file_delete',
		'perm' => [we_base_perm::WORK_COLLECTION_DELETE],
		'hide' => $seeMode
	], [// File > Delete > Collection
		'text' => g_l('global', '[vfile]'),
		'parent' => 'file_delete',
		'cmd' => 'delete_collections',
		'perm' => [we_base_perm::WORK_COLLECTION_DELETE],
		'hide' => $seeMode || !we_modules_info::isActive(we_modules_info::COLLECTION),
	],
	'file_mv' => [// File > Move
		'text' => g_l('menu_global', '[move]'),
		'parent' => we_base_menu::E_FILE,
		'hide' => $seeMode,
		'perm' => [we_base_perm::WORK_DOCUMENT_MOVE, we_base_perm::OBJECTFILE_MOVE, we_base_perm::WORK_TEMPLATE_MOVE],
	], [// File > Move > Documents
		'text' => g_l('menu_global', '[documents]'),
		'parent' => 'file_mv',
		'cmd' => 'move_documents',
		'perm' => [we_base_perm::WORK_DOCUMENT_MOVE],
		'hide' => $seeMode,
	], [// File > move > objects
		'text' => g_l('menu_object', '[objects]'),
		'parent' => 'file_mv',
		'cmd' => 'move_objectfile',
		'perm' => [we_base_perm::OBJECTFILE_MOVE],
		'hide' => !we_modules_info::isActive(we_modules_info::OBJECT) || ($_SESSION['weS']['we_mode'] != we_base_constants::MODE_NORMAL)
	], [
		'parent' => 'file_mv',
		'perm' => [we_base_perm::WORK_TEMPLATE_MOVE],
		'hide' => $seeMode
	],
	[// File > Move > Templates
		'text' => g_l('menu_global', '[templates]'),
		'parent' => 'file_mv',
		'cmd' => 'move_templates',
		'perm' => [we_base_perm::WORK_TEMPLATE_MOVE],
		'hide' => $seeMode,
	],
	'file_addcoll' => [// File > add to collection
		'text' => g_l('menu_global', '[add_to_collection]'),
		'parent' => we_base_menu::E_FILE,
		'perm' => [we_base_perm::WORK_COLLECTION_SAVE],
		'hide' => $seeMode || !we_modules_info::isActive(we_modules_info::COLLECTION)
	], [// File > add to collection > documents
		'text' => g_l('menu_global', '[documents]'),
		'parent' => 'file_addcoll',
		'cmd' => 'add_documents_to_collection',
		'perm' => [we_base_perm::WORK_COLLECTION_SAVE],
		'hide' => $seeMode || !we_modules_info::isActive(we_modules_info::COLLECTION),
	], [/// File > add to collection > objects
		'text' => g_l('menu_object', '[objects]'),
		'parent' => 'file_addcoll',
		'cmd' => 'add_objectfiles_to_collection',
		'perm' => [we_base_perm::WORK_COLLECTION_SAVE],
		'hide' => true,
	], [
		'parent' => we_base_menu::E_FILE,
		'hide' => $seeMode
	],
	/*
	  'text' => g_l('menu_glossary', '[glossary_check]'),
	  'parent' => we_base_menu::E_FILE,
	  'cmd' => 'glossary_check',
	  'hide' => !(we_modules_info::isActive(we_modules_info::GLOSSARY))
	  ,
	  [// File > Delete Active Document
	  'text' => g_l('menu_global', '[delete_active_document]'),
	  'parent' => we_base_menu::E_FILE,
	  'cmd' => 'delete_single_document_question',
	  'perm' => [we_base_perm::WORK_DOCUMENT_DELETE, we_base_perm::OBJECTFILE_DELETE, we_base_perm::WORK_TEMPLATE_DELETE, we_base_perm::OBJECT_DELETE],
	  'hide' => $seeMode
	  ],
	 */
	[// File > Close All
		'text' => g_l('menu_global', '[close_all_documents]'),
		'parent' => we_base_menu::E_FILE,
		'cmd' => 'close_all_documents',
		'hide' => $seeMode
	], [// File > Close All But this
		'text' => g_l('menu_global', '[close_all_but_active_document]'),
		'parent' => we_base_menu::E_FILE,
		'cmd' => 'close_all_but_active_document',
		'hide' => $seeMode
	], [
		'parent' => we_base_menu::E_FILE
	],
	'file_search' => [// File > Search
		'text' => g_l('searchtool', '[suchen]'),
		'parent' => we_base_menu::E_FILE,
	], [// File > Search
		'text' => g_l('menu_global', '[search]') . '&hellip;',
		'parent' => 'file_search',
		'cmd' => 'weSearch_edit',
	],
	[// File > unpublished pages
		'text' => g_l('menu_global', '[media]') . '&hellip;',
		'parent' => 'file_search',
		'cmd' => ['weSearch_edit', '', '', 0, 5],
		'perm' => [we_base_perm::WORK_DOCUMENTS_CAN_SEE],
	],
	[// File > unpublished pages
		'text' => g_l('menu_global', '[unpublished_pages]') . '&hellip;',
		'parent' => 'file_search',
		'cmd' => 'openUnpublishedPages',
		'perm' => [we_base_perm::WORK_DOCUMENTS_CAN_SEE],
	], [// File > unpublished objects
		'text' => g_l('menu_object', '[unpublished_objects]') . '&hellip;',
		'parent' => 'file_search',
		'cmd' => 'openUnpublishedObjects',
		'perm' => [we_base_perm::OBJECTFILES_CAN_SEE],
		'hide' => !we_modules_info::isActive(we_modules_info::OBJECT)
	], [
		'parent' => we_base_menu::E_FILE,
	],
	'file_imex' => [// File > Import/Export
		'text' => g_l('menu_global', '[import_export]'),
		'parent' => we_base_menu::E_FILE,
		'perm' => [we_base_perm::EXIM_EXPORT_GENERICXML, we_base_perm::EXIM_EXPORT_CSV, we_base_perm::EXIM_IMPORT_FILE, we_base_perm::EXIM_IMPORT_SITE, we_base_perm::EXIM_IMPORT_GENERICXML,
			we_base_perm::EXIM_IMPORT_CSV,
			we_base_perm::EXIM_IMPORT_WXML, we_base_perm::EXIM_EXPORTNODOWNLOAD, we_base_perm::EXIM_EXPORT, we_base_perm::EXIM_EXPORT_EDIT, we_base_perm::EXIM_EXPORT_MAKE],
	], [// File > Import/Export > Import
		'text' => g_l('menu_global', '[import]') . '&hellip;',
		'cmd' => 'import',
		'parent' => 'file_imex',
		'perm' => [we_base_perm::EXIM_IMPORT_FILE, we_base_perm::EXIM_IMPORT_SITE, we_base_perm::EXIM_IMPORT_GENERICXML, we_base_perm::EXIM_IMPORT_CSV, we_base_perm::EXIM_IMPORT_WXML],
	], [// File > Import/Export > Export
		'text' => g_l('menu_global', '[export]') . '&hellip;',
		'cmd' => 'export_edit',
		'parent' => 'file_imex',
		'perm' => [we_base_perm::EXIM_EXPORT_GENERICXML, we_base_perm::EXIM_EXPORT_CSV, we_base_perm::EXIM_EXPORTNODOWNLOAD, we_base_perm::EXIM_EXPORT, we_base_perm::EXIM_EXPORT_EDIT,
			we_base_perm::EXIM_EXPORT_MAKE],
		'hide' => !we_modules_info::isActive(we_modules_info::EXPORT),
	],
	[// File > rebuild
		'text' => g_l('menu_global', '[rebuild]') . '&hellip;',
		'parent' => we_base_menu::E_FILE,
		'cmd' => 'rebuild',
		'perm' => [we_base_perm::REBUILD],
	],
	'cockpit' => [// Cockpit
		'text' => g_l('global', '[cockpit]'),
		'perm' => [we_base_perm::WORK_QUICKSTART_CAN_SEE],
		'icon' => 'fa fa-th-large'
	], [// Cockpit > Display
		'text' => g_l('menu_global', '[display]'),
		'parent' => 'cockpit',
		'cmd' => 'home',
		'perm' => [we_base_perm::WORK_QUICKSTART_CAN_SEE],
	],
	'cockpit_new' => [// Cockpit > new Widget
		'text' => g_l('menu_global', '[new_widget]'),
		'parent' => 'cockpit',
		'perm' => [we_base_perm::WORK_QUICKSTART_CAN_SEE],
	], [// Cockpit > new Widget > shortcuts
		'text' => g_l('menu_global', '[shortcuts]'),
		'parent' => 'cockpit_new',
		'cmd' => ['new_widget', 'sct'],
		'perm' => [we_base_perm::WORK_QUICKSTART_CAN_SEE],
	], [// Cockpit > new Widget > RSS
		'text' => g_l('menu_global', '[rss_reader]'),
		'parent' => 'cockpit_new',
		'cmd' => ['new_widget', 'rss'],
		'perm' => [we_base_perm::WORK_QUICKSTART_CAN_SEE],
	], [// Cockpit > new Widget > Shop
		'text' => g_l('menu_global', '[shop_dashboard]'),
		'parent' => 'cockpit_new',
		'cmd' => ['new_widget', 'shp'],
		'perm' => [we_base_perm::WORK_QUICKSTART_CAN_SEE, we_base_perm::SHOP_NEW_ARTICLE, we_base_perm::SHOP_DELETE_ARTICLE, we_base_perm::SHOP_EDIT_ORDER, we_base_perm::SHOP_DELETE_ORDER,
			we_base_perm::SHOP_EDIT_PREFS],
		'hide' => !we_modules_info::isActive(we_modules_info::SHOP)
	], [// Cockpit > new Widget > online users
		'text' => g_l('menu_global', '[users_online]'),
		'parent' => 'cockpit_new',
		'cmd' => ['new_widget', 'usr'],
		'perm' => [we_base_perm::WORK_QUICKSTART_CAN_SEE, we_base_perm::WIDGET_SHOW_USR],
	], [// Cockpit > new Widget > lastmodified
		'text' => g_l('menu_global', '[last_modified]'),
		'parent' => 'cockpit_new',
		'cmd' => ['new_widget', 'mfd'],
		'perm' => [we_base_perm::WORK_QUICKSTART_CAN_SEE],
	], [// Cockpit > new Widget > unpublished
		'text' => g_l('menu_global', '[unpublished]'),
		'parent' => 'cockpit_new',
		'cmd' => ['new_widget', 'upb'],
		'perm' => [we_base_perm::WORK_QUICKSTART_CAN_SEE],
	], [// Cockpit > new Widget > my Documents
		'text' => g_l('menu_global', '[my_documents]'),
		'parent' => 'cockpit_new',
		'cmd' => ['new_widget', 'mdc'],
		'perm' => [we_base_perm::WORK_QUICKSTART_CAN_SEE],
	], [// Cockpit > new Widget > Notepad
		'text' => g_l('menu_global', '[notepad]'),
		'parent' => 'cockpit_new',
		'cmd' => ['new_widget', 'pad'],
		'perm' => [we_base_perm::WORK_QUICKSTART_CAN_SEE],
	], [
		'text' => g_l('menu_global', '[kv_failedLogins]'),
		'parent' => 'cockpit_new',
		'cmd' => ['new_widget', 'fdl'],
		'perm' => [we_base_perm::CUSTOMER_EDIT, we_base_perm::CUSTOMER_NEW],
		'hide' => !we_modules_info::isActive(we_modules_info::CUSTOMER) || !we_base_permission::hasPerm(we_base_perm::WORK_QUICKSTART_CAN_SEE),
	], [// Cockpit > new Widget > default settings
		'text' => g_l('menu_global', '[default_settings]'),
		'parent' => 'cockpit',
		'cmd' => 'reset_home',
		'perm' => [we_base_perm::WORK_QUICKSTART_CAN_SEE],
	],
	'modules' => [
		'text' => g_l('menu_global', '[modules]'),
		'icon' => 'fa fa-cubes',
	],
	we_base_menu::E_SETTINGS => [
		'text' => g_l('menu_global', '[preferences]'), //g_l('menu_global', '[extras]'),
		'icon' => 'fa fa-gears'
	],
	[// Extras > change password
		'text' => g_l('menu_global', '[change_password]') . '&hellip;',
		'parent' => we_base_menu::E_SETTINGS,
		'cmd' => 'change_passwd',
		'perm' => [we_base_perm::USER_EDIT_PASSWD],
	], ['parent' => we_base_menu::E_SETTINGS,
		'perm' => [we_base_perm::USER_EDIT_PASSWD],
	],
	we_base_menu::E_HELP => [
		'text' => g_l('menu_global', '[help]'),
		'icon' => 'fa fa-question-circle'
	],
	[
		'text' => g_l('menu_global', '[sidebar]') . '&hellip;',
		'parent' => we_base_menu::E_HELP,
		'cmd' => 'openSidebar',
		'hide' => !(SIDEBAR_DISABLED == 0)
	], ['parent' => we_base_menu::E_HELP,
		'perm' => [we_base_perm::ADMINISTRATOR],
	], [
		'text' => g_l('menu_global', '[webEdition_online]') . '&hellip;',
		'parent' => we_base_menu::E_HELP,
		'cmd' => 'webEdition_online',
	],
	/* 'online-help' => [
	  'text' => g_l('menu_global', '[onlinehelp]'),
	  'parent' => we_base_menu::E_HELP,
	  'hide' => $seeMode
	  ], */ [
		'text' => g_l('menu_global', '[onlinehelp_documentation]') . '&hellip;',
		'parent' => we_base_menu::E_HELP,
		'cmd' => 'help_documentation',
		'hide' => $seeMode
	], [
		'text' => g_l('menu_global', '[onlinehelp_tagreference]') . '&hellip;',
		'parent' => we_base_menu::E_HELP,
		'cmd' => 'help_tagreference',
		'perm' => [we_base_perm::WORK_TEMPLATES_CAN_SEE],
		'hide' => $seeMode
	], [
		'text' => g_l('menu_global', '[onlinehelp_forum]') . '&hellip;',
		'parent' => we_base_menu::E_HELP,
		'cmd' => 'help_forum',
		'hide' => $seeMode
	], [
		'text' => g_l('menu_global', '[onlinehelp_bugtracker]') . '&hellip;',
		'parent' => we_base_menu::E_HELP,
		'cmd' => 'help_bugtracker',
		'hide' => $seeMode
	], [
		'text' => g_l('menu_global', '[onlinehelp_changelog]') . '&hellip;',
		'parent' => we_base_menu::E_HELP,
		'cmd' => 'help_changelog',
		'hide' => $seeMode
	], ['parent' => we_base_menu::E_HELP,
		'perm' => [we_base_perm::ADMINISTRATOR],
	], [
		'text' => g_l('menu_global', '[info]') . '&hellip;',
		'parent' => we_base_menu::E_HELP,
		'cmd' => 'info',
	]
];

$dtq = we_doctype_docTypes::getDoctypeQuery($GLOBALS['DB_WE'], false, true);
$GLOBALS['DB_WE']->query('SELECT dt.ID,dt.DocType,dt.isFolder,dt.ParentID FROM ' . DOC_TYPES_TABLE . ' dt LEFT JOIN ' . FILE_TABLE . ' dtf ON dt.ParentFileID=dtf.ID ' . $dtq['join'] . ' WHERE ' . $dtq['where']);

if($GLOBALS['DB_WE']->num_rows() && we_base_permission::hasPerm(we_base_perm::WORK_DOCUMENT_NO_DOCTYPE_ALLOWED)){
	$we_menu[] = ['parent' => 'file_new_wedoc0']; // separator
}
// New > webEdition Document > Doctypes*
while($GLOBALS['DB_WE']->next_record()){
	if($GLOBALS['DB_WE']->f('isFolder')){
		$we_menu['file_new_wedoc' . $GLOBALS['DB_WE']->f('ID')] = [
			'text' => strtr($GLOBALS['DB_WE']->f('DocType'), [',' => ' ', '"' => '', '\'' => '',]),
			'parent' => 'file_new_wedoc' . $GLOBALS['DB_WE']->f('ParentID'),
			'perm' => [we_base_perm::WORK_DOCUMENT_WEBEDITION_NEW],
		];
	} else {
		$we_menu[] = [
			'text' => strtr($GLOBALS['DB_WE']->f('DocType'), [',' => ' ', '"' => '', '\'' => '',]),
			'parent' => 'file_new_wedoc' . $GLOBALS['DB_WE']->f('ParentID'),
			'cmd' => ['new_dtPage', $GLOBALS['DB_WE']->f('ID')],
			'perm' => [we_base_perm::WORK_DOCUMENT_WEBEDITION_NEW],
		];
	}
}

if(we_modules_info::isActive(we_modules_info::OBJECT)){
	// object from which class
	$ac = we_users_util::getAllowedClasses($GLOBALS['DB_WE']);
	if($ac){
		$GLOBALS['DB_WE']->query('SELECT ID,Text FROM ' . OBJECT_TABLE . ' ' . ($ac ? ' WHERE ID IN(' . implode(',', $ac) . ') ' : '') . 'ORDER BY Text');

		if($GLOBALS['DB_WE']->num_rows()){
			while($GLOBALS['DB_WE']->next_record()){
				$we_menu[] = [
					'text' => strtr($GLOBALS['DB_WE']->f('Text'), ['"' => '', '\'' => '']),
					'parent' => 'file_new_weobj',
					'cmd' => ['new_ClObjectFile', $GLOBALS['DB_WE']->f('ID')],
					'perm' => [we_base_perm::OBJECTFILE_NEW],
				];
			}
		} else {
			$we_menu['file_new_weobj']['hide'] = 1;
		}
	}
}

foreach(we_modules_info::showModuleInMenu(we_base_menu::E_MODULE, '') as $modInfo){
	$we_menu[] = [
		'text' => $modInfo['text'] . '&hellip;',
		'parent' => 'modules',
		'cmd' => $modInfo['name'] . '_edit',
		'perm' => empty($modInfo['perm']) ? [] : $modInfo['perm'],
	];
}

//add basic settings, formarly modules
foreach(we_modules_info::showModuleInMenu(we_base_menu::E_SETTINGS, '') as $modInfo){
	$we_menu[] = [
		'text' => $modInfo['text'] . '&hellip;',
		'parent' => we_base_menu::E_SETTINGS,
		'cmd' => $modInfo['name'] . '_edit',
		'perm' => isset($modInfo['perm']) ? $modInfo['perm'] : [],
	];
}

//add the rest of the menu
$we_menu = array_merge($we_menu, [
	[// Extras > Metadata fields
		'text' => g_l('menu_global', '[metadata]') . '&hellip;',
		'parent' => we_base_menu::E_SETTINGS,
		'cmd' => 'editMetadataFields',
		'perm' => [we_base_perm::ADMINISTRATOR],
		'hide' => $seeMode
	],
	'settingsEntry' => [
		'parent' => we_base_menu::E_SETTINGS,
		'perm' => [we_base_perm::USER_EDIT_SETTINGS],
	],
	/* dialog does not work correctly
	 * [// Extras > versioning
	  'text' => g_l('menu_global', '[versioning]') . '&hellip;',
	  'parent' => we_base_menu::E_SETTINGS,
	  'cmd' => 'versions_wizard',
	  'perm' => [we_base_perm::ADMINISTRATOR],
	  ], */
	[
		'text' => g_l('menu_global', '[common]') . '&hellip;',
		'parent' => we_base_menu::E_SETTINGS,
		'cmd' => 'openPreferences',
		'perm' => [we_base_perm::USER_EDIT_SETTINGS],
	],
	'moduleSettings' => [
		'text' => g_l('menu_global', '[moduleSettings]') . '&hellip;',
		'parent' => we_base_menu::E_SETTINGS,
		'perm' => [we_base_perm::ADMINISTRATOR],
	],
	[
		'parent' => we_base_menu::E_SETTINGS,
		'perm' => [we_base_perm::ADMINISTRATOR],
	],
	'file_backup' => [// File > Backup
		'text' => g_l('menu_global', '[backup]'),
		'parent' => we_base_menu::E_SETTINGS,
		'hide' => $seeMode,
		'perm' => [we_base_perm::EXIM_BACKUPLOG, we_base_perm::EXIM_IMPORT, we_base_perm::EXIM_EXPORT, we_base_perm::EXIM_EXPORTNODOWNLOAD],
	], [// File > Backup > make
		'text' => g_l('menu_global', '[make_backup]') . '&hellip;',
		'parent' => $seeMode ? we_base_menu::E_FILE : 'file_backup',
		'cmd' => 'make_backup',
		'perm' => [we_base_perm::EXIM_EXPORT, we_base_perm::EXIM_EXPORTNODOWNLOAD],
	], [// File > Backup > recover
		'text' => g_l('menu_global', '[recover_backup]') . '&hellip;',
		'parent' => 'file_backup',
		'cmd' => 'recover_backup',
		'perm' => [we_base_perm::EXIM_IMPORT],
		'hide' => $seeMode
	], [// File > Backup > view Log
		'text' => g_l('menu_global', '[view_backuplog]') . '&hellip;',
		'parent' => $seeMode ? we_base_menu::E_FILE : 'file_backup',
		'cmd' => 'view_backuplog',
		'perm' => [we_base_perm::EXIM_BACKUPLOG],
	],
	[// File > rebuild
		'text' => g_l('menu_global', '[rebuild]') . '&hellip;',
		'parent' => we_base_menu::E_SETTINGS,
		'cmd' => 'rebuild',
		'perm' => [we_base_perm::REBUILD],
	],
	[// File > Browse server
		'text' => g_l('menu_global', '[browse_server]') . '&hellip;',
		'parent' => we_base_menu::E_SETTINGS,
		'cmd' => 'browse_server',
		'perm' => [we_base_perm::WORK_BROWSE_SERVER],
		'hide' => $seeMode,
	],
	['parent' => we_base_menu::E_SETTINGS
	],
	['text' => g_l('menu_global', '[update]') . '&hellip;',
		'parent' => we_base_menu::E_SETTINGS,
		'cmd' => 'update',
		'perm' => [we_base_perm::ADMINISTRATOR],
	], ['text' => g_l('menu_global', '[sysinfo]') . '&hellip;',
		'parent' => we_base_menu::E_SETTINGS,
		'cmd' => 'sysinfo',
		'perm' => [we_base_perm::ADMINISTRATOR],
	], [
		'text' => g_l('menu_global', '[showerrorlog]') . '&hellip;',
		'parent' => we_base_menu::E_SETTINGS,
		'cmd' => 'showerrorlog',
		'perm' => [we_base_perm::ADMINISTRATOR],
	],
	[// Extras > versioning-log
		'text' => g_l('menu_global', '[versioning_log]') . '&hellip;',
		'parent' => we_base_menu::E_SETTINGS,
		'cmd' => 'versioning_log',
		'perm' => [we_base_perm::ADMINISTRATOR],
	],
	]);


foreach(we_modules_info::showModuleInMenu('', 'hasSettings') as $modInfo){
	$we_menu[] = [
		'text' => $modInfo['text'] . '&hellip;',
		'parent' => 'moduleSettings',
		'cmd' => 'edit_settings_' . $modInfo['name'],
		'perm' => isset($modInfo['perm']) ? $modInfo['perm'] : [],
	];
}


return $we_menu;
