<?php
/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
return [
	'new' => [
		'text' => g_l('export', '[new]'),
		'icon' => 'fa fa-plus-circle',
	],
	[
		'text' => g_l('export', '[export]'),
		'cmd' => 'new_export',
		'perm' => [we_base_perm::EXIM_EXPORT_NEW],
		'parent' => 'new',
	],
	[
		'text' => g_l('export', '[group]'),
		'cmd' => 'new_export_group',
		'perm' => [we_base_perm::EXIM_EXPORT_NEW],
		'parent' => 'new',
	],
	'export' => [
		'text' => g_l('export', '[export]'),
		'icon' => 'fa fa-download'
	],
	[
		'text' => g_l('export', '[save]'),
		'parent' => 'export',
		'cmd' => 'save_export',
		'perm' => [we_base_perm::EXIM_EXPORT_NEW, we_base_perm::EXIM_EXPORT_EDIT],
	],
	[
		'text' => g_l('export', '[delete]'),
		'parent' => 'export',
		'cmd' => 'delete_export',
		'perm' => [we_base_perm::EXIM_EXPORT_DELETE],
	],
	['parent' => 'export',],
	[
		'text' => g_l('export', '[quit]'),
		'parent' => 'export',
		'cmd' => 'exit_export',
	],
];
