<?php

/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_dialog_deleteProgress{

	public static function getDialog(){

		switch(we_base_request::_(we_base_request::STRING, 'frame', '')){
			case 'main':
				echo self::main();
				break;
			case 'cmd':
				echo self::cmd();
				break;
			default:
				echo self::getHTML(we_base_request::_(we_base_request::TABLE, "table"), we_base_request::_(we_base_request::INT, "currentID", 0));
		}
	}

	private static function main(){
		$WE_PB = new we_gui_progressBar(0, 490);
		$WE_PB->addText("", we_gui_progressBar::TOP, "pb1");

		$cancelButton = we_html_button::create_button(we_html_button::CANCEL, "javascript:top.close();");
		$pb = we_html_tools::dialogLayout($WE_PB->getHTML(), g_l('delete', '[delete]'), $cancelButton);

		return we_html_tools::getHtmlTop('', '', '', we_gui_progressBar::getJSCode(), we_html_element::body(['class' => 'weDialogBody'], $pb));
	}

	private static function getHTML($table, $currentID){
		return we_html_tools::getHtmlTop(g_l('delete', '[delete]'), '', '', '', we_html_element::body(['id' => 'weMainBody', 'onload' => "delcmd.location=WE().consts.dirs.WEBEDITION_DIR+'we_cmd.php?we_cmd[0]=delFrag&frame=cmd" . ($table ? ("&amp;table=" . rawurlencode($table)) : "") . "&currentID=" . $currentID . "';"]
					, we_html_element::iframe('delmain', WEBEDITION_DIR . "we_cmd.php?we_cmd[0]=delFrag&frame=main", 'position:absolute;top:0;bottom:0;left:0;right:0;overflow: hidden') .
					we_html_element::iframe('delcmd', "about:blank", 'position:absolute;bottom:0;height:0;left:0;right:0;overflow: hidden;')
				)
		);
	}

	private static function cmd(){
		if(!empty($_SESSION['weS']['backup_delete'])){
			$taskname = md5(session_id() . '_backupdel');
			new we_fragment_backupDelete($taskname);
		} else {
			$taskname = md5(session_id() . '_del');
			$table = we_base_request::_(we_base_request::TABLE, 'table', FILE_TABLE);
			new we_fragment_del($taskname, $table);
		}
		return '';
	}

}
