<?php

/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_fileupload_ui_importer extends we_fileupload_ui_base{ // FIXME: extend ui_preview

	public function __construct($name, array $acceptedCT = [], array $acceptedExt = [], array $forbiddenCT = [], array $forbiddenExt = []){
		$this->noPermsCT = $this->getForbiddenCtsFromPerms();

		parent::__construct('we_File', $acceptedCT, $acceptedExt, $forbiddenCT, $forbiddenExt);
		$this->responseClass = 'we_fileupload_resp_multiimport';

		$this->type = 'importer';
		$this->isMultiUpload = true;
		$this->doCommitFile = true;

		$this->isMultiselect = true;

		$this->controls = [
			'showControls' => self::CONTROLS_SHOW_TRUE,
			'showControlsInitialState' => self::CONTROLS_SHOW_TRUE,
			'showBtnsUploadCancel' => self::CONTROLS_SHOW_FALSE,
			'showEditOptions' => self::CONTROLS_SHOW_TRUE,
			'showImportMeta' => self::CONTROLS_SHOW_FALSE
		];

		$this->itemControlls['showDelete'] = self::CONTROLS_SHOW_TRUE;
	}

	public function getHTML($hiddens = ''){
		$topParts = [['html' => $this->getFormUploader($this->getDropZoneContent(), false)]];

		$uploaderBusy = we_html_element::div(['class' => 'containerUploaderBusy'], we_html_element::div(['class' => 'elemSpinner'], '<i class="fa fa-2x fa-spinner fa-pulse"></i>') .
				we_html_element::div(['class' => 'elemText'])
		);

		$content = we_html_element::hiddens(['we_cmd[0]' => 'import_files', 'cmd' => 'content']) .
			we_html_element::div(['class' => 'fileuploadImporter'], we_html_element::form(['action' => '',
					'name' => 'we_form',
					'enctype' => 'multipart/form-data'
					], $hiddens .
					we_html_element::div(['class' => 'dialogboxTop'], we_html_multiIconBox::getHTML("selectFiles", $topParts, 30, '', -1, '', '', '', g_l('importFiles', '[step2]'))) .
					we_html_element::div(['id' => 'div_upload_files', 'class' => 'importer_containerUploadFiles'], self::getHtmlLoup() . we_html_multiIconBox::getHTML("uploadFiles", [], 30, '', -1, '', '', '', ''))
				) . we_html_element::div(['class' => 'uploaderMask hidden']) . $uploaderBusy
		);

		return we_html_element::body(['class' => 'weDialogBody'], $content);
	}

	public function getJs(){
		return self::getJSFileuploader() . self::getJSUtils() . $this->getJSInit();
	}

	//TODO: add param filetype
	public static function getBtnImportFiles($parentID = 0, $cmdUploadFinished = '', $text = ''){
		return we_html_button::create_button('fa:' . ($text ?: 'btn_import_files') . ',fa-lg fa-upload', "javascript:we_cmd('import_files','" . $parentID . "', '" . $cmdUploadFinished . "')");
	}

}
