<?php

/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_fileupload_ui_wedoc extends we_fileupload_ui_base{
	protected $documentCT = we_base_ContentTypes::APPLICATION;

	public function __construct($name, array $acceptedCT = [], array $acceptedExt = [], array $forbiddenCT = [], array $forbiddenExt = [], array $fileinfo = []){
		$this->documentCT = empty($acceptedCT[0]) ? $this->documentCT : $acceptedCT[0];
		if(in_array($this->documentCT, [we_base_ContentTypes::APPLICATION, $acceptedCT === we_base_ContentTypes::PDF])){
			$forbiddenExt = we_base_ContentTypes::getExtension(we_base_ContentTypes::IMAGE);
		}
		$this->noPermsCT = $this->getForbiddenCtsFromPerms();

		parent::__construct('we_File', $acceptedCT, $acceptedExt, $forbiddenCT, $forbiddenExt);

		$this->type = 'wedoc';
		$this->fileinfo = $fileinfo;
		$this->doCommitFile = true;
		$this->doImport = true;
		$this->responseClass = 'we_fileupload_resp_import';

		$this->controls = [
			'showControls' => $this->fileinfo['isempty'] ? self::CONTROLS_SHOW_TRUE : self::CONTROLS_SHOW_AUTO,
			'showControlsInitialState' => $this->fileinfo['isempty'] ? self::CONTROLS_SHOW_TRUE : self::CONTROLS_SHOW_FALSE,
			'showBtnsUploadCancel' => self::CONTROLS_SHOW_TRUE,
			'showEditOptions' => $this->documentCT === we_base_ContentTypes::IMAGE ? self::CONTROLS_SHOW_TRUE : self::CONTROLS_SHOW_FALSE,
			// showImportMeta temporarily deactivated for PDFs: import of pfd-metas to custom metadata fields not yet implemented
			'showImportMeta' => in_array($this->documentCT, [we_base_ContentTypes::IMAGE/*, we_base_ContentTypes::PDF*/]) ? self::CONTROLS_SHOW_TRUE : self::CONTROLS_SHOW_FALSE
		];
	}

	public function getHTML(){
		return $this->getJs() . $this->getCss() . $this->getHiddens() . we_html_element::div(['class' => 'fileuploadWedoc'], $this->getFormUploader($this->getDropZoneContent()));
	}

	public function getJs(){
		// if IE we load uploader utils on editor
		return (we_base_browserDetect::inst()->getBrowser() === we_base_browserDetect::IE ? self::getJSUtils() : '') . $this->getJSInit();
	}

}
