<?php

/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_listview_shopItems extends we_listview_objectBase{
	const DOCUMENT = 'w';
	const OBJECT = 'o';

	var $type;
	private $ShoppingCart;
	private $ShoppingCartItems;
	private $ShoppingCartKey = '';
	var $ActItem;

	public function __construct($shoppingCart){
		parent::__construct();
		if(is_object($shoppingCart)){
			$this->ShoppingCart = $shoppingCart;
			$this->ShoppingCartItems = $shoppingCart->getShoppingItems();
		} else {
			t_e('called with non object');
		}

		$this->IDs = array_keys($this->ShoppingCartItems);
		$this->anz = count($this->IDs);
	}

	function next_record(){
		if($this->count >= $this->anz){
			return false;
		}

		$cartKey = $this->IDs[$this->count];
		$shoppingCartItems = $this->ShoppingCartItems[$cartKey];
		$this->ShoppingCartKey = $cartKey;
		$this->ActItem = $shoppingCartItems;

		$this->Record = [];
		foreach($shoppingCartItems['serial'] as $key => $value){
			if(!is_int($key)){
				$this->Record[strtolower($key)] = $value;
			}
		}
		$this->count++;
		return true;
	}

	public function f($key, $stripWE = true){
		return parent::f($key, $stripWE);
	}

	function getCustomFieldsAsRequest(){
		return $this->ActItem['customFields'] ?
			[we_shop_shop::ARTICLE_CUSTOM_FIELD => $this->ActItem['customFields']] :
			[];
	}

	function getActItemField($field){
		return $this->ActItem[$field];
	}

	public function getShoppingCartKey(){
		return $this->ShoppingCartKey;
	}

}
