<?php

/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_rpcCmd_errorJSTrigger extends we_rpc_cmd{

	function execute(){
		if(isset($_REQUEST['we_cmd']) && function_exists('log_error_message')){
			$br = we_base_browserDetect::inst();
			$line = we_base_request::_(we_base_request::INT, 'we_cmd', 0, 'line');

			if($br->getBrowser() == we_base_browserDetect::IE && $line == 111){
				//bad ie, don't log this anymore
				return '';
			}
			$file = we_base_request::_(we_base_request::STRING, 'we_cmd', '', 'file');
			$errobj = we_base_request::_(we_base_request::STRING, 'we_cmd', true, 'errObj');
			unset($_REQUEST['we_cmd']['file'], $_REQUEST['we_cmd']['line'], $_REQUEST['we_cmd']['errObj']);

			$_REQUEST['we_cmd']['detected'] = [
				'Browser' => $br->getBrowser() . ' ' . $br->getBrowserVersion(),
				'System' => $br->getSystem(),
			];
			$data = str_replace($_SERVER['SERVER_NAME'], 'HOST', print_r($_REQUEST['we_cmd'], true));
			unset($_REQUEST);
			we_error_handler::log(we_error_handler::E_JS, $data, $file, $line, $errobj);
		}
		return new we_rpc_response();
	}

}
