<?php

/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_users_frames extends we_modules_frame{

	public function __construct($frameset){
		parent::__construct($frameset);
		$this->module = we_modules_info::USERS;
		$this->Tree = new we_tree_users($this->jsCmd);
		$this->showTreeFooter = true;
		$this->View = new we_users_view();
	}

	protected function getHTMLCmd(){
		if(($pid = we_base_request::_(we_base_request::RAW, "pid")) === false){
			//use this to get js code
			return $this->getHTMLDocument(we_html_element::body(), $this->jsCmd->getCmds());
		}

		$offset = we_base_request::_(we_base_request::INT, "offset", 0);
		$this->jsCmd->addCmd('loadTree', ['clear' => !$pid, 'items' => we_tree_users::getItems($pid, $offset, $this->Tree->default_segment)]);

		return $this->getHTMLDocument(
						we_html_element::body([], we_html_element::form(['name' => 'we_form'], we_html_element::hiddens(['pnt' => "cmd",
											'cmd' => "no_cmd"])
								)
						)
		);
	}

	/* use parent
	  function getHTMLLeft(){}
	 *
	 */

	protected function getHTMLTreeFooter(){
		return $this->getHTMLSearchTreeFooter();
	}

	protected function getHTMLEditorHeader($mode = 0){
		if(we_base_request::_(we_base_request::BOOL, 'home')){//FIXME: find one working condition
			return parent::getHTMLEditorHeader(0);
		}
		$user_object = $_SESSION['user_session_data'];
		return $this->getHTMLDocument(we_html_element::body(['onresize' => 'weTabs.setFrameSize()', 'onload' => 'weTabs.setFrameSize()', 'id' => 'eHeaderBody']), $user_object->formHeader(we_base_request::_(we_base_request::INT, "tab", 0)));
	}

	protected function getHTMLEditorBody(){
		if(we_base_request::_(we_base_request::BOOL, 'home')){
			return $this->View->getHomeScreen();
		}
		$weSuggest = & we_gui_suggest::getInstance();

		$user_object = (isset($_SESSION['user_session_data']) ?
				$_SESSION['user_session_data'] :
				new we_users_user());

		$js = $this->View->getJSProperty();
		$tab = we_base_request::_(we_base_request::INT, 'tab', 0);
		$content = we_html_element::hiddens([
					'cmd' => '',
					"tab" => $tab,
					"oldtab" => $tab,
					"obj_name" => $user_object->Name,
					"uid" => $user_object->ID,
					"ctype" => oldHtmlspecialchars(we_base_request::_(we_base_request::STRING, "ctype", '')),
					"ctable" => oldHtmlspecialchars(we_base_request::_(we_base_request::STRING, "ctable", '')),
					"sd" => 0]);

		if($user_object){
			if(($oldTab = we_base_request::_(we_base_request::INT, 'oldtab')) !== false){

				$user_object->preserveState($oldTab);
				$_SESSION['user_session_data'] = $user_object;
			}
			if(($start = we_base_request::_(we_base_request::INT, 'seem_start_file')) !== false){
				$_SESSION['save_user_seem_start_file'][we_base_request::_(we_base_request::INT, "uid")] = $start;
			}
			$content .= $user_object->formDefinition($this->jsCmd, $tab);
		}

		$form = we_html_element::form(['name' => 'we_form',
					'method' => 'post',
					'autocomplete' => 'off',
					'onsubmit' => 'return false'
						], $content);
		return $this->getHTMLDocument(we_html_element::body(['class' => 'weEditorBody', 'onload' => 'loaded=1;', 'onunload' => 'doUnload()'], $form), we_html_element::jsScript(JS_DIR . 'multiIconBox.js') . $js);
	}

	function getHTMLSearch(){
		$keyword = we_base_request::_(we_base_request::RAW, 'keyword', "");
		$arr = explode(' ', strToLower($keyword));
		$DB_WE = $GLOBALS['DB_WE'];

		$array_and = [];
		$array_or = [];
		$array_not = [];

		for($i = 0; $i < count($arr); $i++){
			switch($arr[$i]){
				case 'not':
					$i++;
					$array_not[] = $arr[$i];
					break;
				case 'or':
					$i++;
					$array_or[] = $arr[$i];
					break;
				case 'and':
					$i++;
				//no break
				default:
					$array_and[] = $arr[$i];
					break;
			}
		}
		//FIXME: use persistent_slots to determine all fields
		$searchStr = '(First LIKE "%###WE###%" OR Second LIKE "%###WE###%" OR username LIKE "%###WE###%" OR Address LIKE "%###WE###%" OR City LIKE "%###WE###%" OR State LIKE "%###WE###%" OR Country LIKE "%###WE###%" OR Telephone LIKE "%###WE###%" OR Fax LIKE "%###WE###%" OR Description LIKE "%###WE###%")';

		$condition = '';
		foreach($array_and as $value){
			$value = $DB_WE->escape($value);
			$condition .= ($condition ? ' AND ' : '') .
					str_replace('###WE###', $value, $searchStr);
		}
		foreach($array_or as $value){
			$value = $DB_WE->escape($value);
			$condition .= ($condition ? ' OR ' : '') .
					str_replace('###WE###', $value, $searchStr);
		}
		foreach($array_not as $value){
			$value = $DB_WE->escape($value);
			$condition .= ($condition ? ' AND NOT ' : '') .
					str_replace('###WE###', $value, $searchStr);
		}
		$DB_WE->query('SELECT ID,CONCAT(Salutation," ",First," ",Second," (",username,")") AS Name FROM ' . USER_TABLE . ($condition ? ' WHERE ' . $condition : '') . ' ORDER BY username');

		if($DB_WE->num_rows()){
			$select = '<select name="search_results" size="20" style="width:520px;height:220px;" ondblclick="top.opener.top.we_cmd(\'check_user_display\',document.we_form.search_results.value); top.close();">';
			while($DB_WE->next_record()){
				$select .= '<option value="' . $DB_WE->f('ID') . '">' . $DB_WE->f('Name') . '</option>';
			}
			$select .= '</select>';
		}else{
		$select = '<div style="background-color:white;width:520px;height:220px;"/>';

		}
		$buttons = we_html_button::position_yes_no_cancel(
						we_html_button::create_button(we_html_button::OPEN_TO_EDIT, "javascript:top.opener.top.we_cmd('check_user_display',document.we_form.search_results.value); if(document.we_form.search_results.value){top.close()}"), null, we_html_button::create_button(we_html_button::CANCEL, "javascript:self.close();")
		);

		$content = we_html_tools::formElementTable(
						we_html_tools::textInput('keyword', $keyword, '', [], 'text', 485), g_l('modules_users', '[search_for]'), "left", "defaultfont", we_html_button::create_button(we_html_button::SEARCH, "javascript:document.we_form.submit();")
				) . '<div style="height:20px;"></div>' .
				we_html_tools::formElementTable($select, g_l('modules_users', '[search_result]'));

		return $this->getHTMLDocument(we_html_element::body(['class' => 'weEditorBody', 'style' => "margin:10px 20px;"], we_html_element::form(['name' => 'we_form',
									'method' => 'post'], we_html_element::hiddens([
											'mod' => 'users',
											'pnt' => 'search']) .
										we_html_tools::dialogLayout($content, g_l('modules_users', '[search]'), $buttons))
		));
	}

	function getHTML($what = '', $mode = '', $step = 0){
		switch($what){
			case 'edfooter':
				return $this->getHTMLEditorFooter([
							we_html_button::FOOTER_SAVE => [[we_base_perm::USER_GROUP_NEW, we_base_perm::USER_NEW, we_base_perm::USER_SAVE, we_base_perm::USER_GROUP_SAVE], 'save_user'],
							we_html_button::FOOTER_TRASH => [[we_base_perm::USER_DELETE, we_base_perm::USER_GROUP_DELETE], 'delete_user']
				]);
			default:
				return parent::getHTML($what, $mode, $step);
		}
	}

}
