<?php

/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
function we_tag_field(array $attribs){
	if(empty($GLOBALS['lv'])){
		return parseError(g_l('parser', '[field_not_in_lv]'));
	}
	//show field in case of e.g. listdir
	if($GLOBALS['lv'] instanceof stdClass){
		return $GLOBALS['lv']->field;
	}
	$lvname = $GLOBALS['lv']->name;

	$orgName = weTag_getAttribute('_name_orig', $attribs, '', we_base_request::STRING);
	$name = weTag_getAttribute('name', $attribs, '', we_base_request::STRING);
	$href = weTag_getAttribute('href', $attribs, '', we_base_request::URL);
	$type = weTag_getAttribute('type', $attribs, '', we_base_request::STRING);
	$alt = weTag_getAttribute('alt', $attribs, '', we_base_request::STRING);
	$tid = weTag_getAttribute('tid', $attribs, 0, we_base_request::INT);
	$hyperlink = weTag_getAttribute('hyperlink', $attribs, false, we_base_request::BOOL);
	$id = weTag_getAttribute('id', $attribs, '', we_base_request::STRING);
	$xml = weTag_getAttribute('xml', $attribs, XHTML_DEFAULT, we_base_request::BOOL);
	$striphtml = weTag_getAttribute('striphtml', $attribs, false, we_base_request::BOOL);
	$only = weTag_getAttribute('only', $attribs, '', we_base_request::STRING);
	$usekey = weTag_getAttribute('usekey', $attribs, false, we_base_request::BOOL);
	$triggerid = weTag_getAttribute('triggerid', $attribs, 0, we_base_request::INT);
	$showpath = weTag_getAttribute('showpath', $attribs);
	$rootdir = weTag_getAttribute('rootdir', $attribs, '', we_base_request::FILE);
	$field = weTag_getAttribute('field', $attribs, '', we_base_request::STRING);
	$max = weTag_getAttribute('max', $attribs, 0, we_base_request::INT);
	$value = weTag_getAttribute('value', $attribs, '', we_base_request::RAW);
	$parentidname = weTag_getAttribute('parentidname', $attribs, 'we_parentid', we_base_request::STRING);
	$listviewname = weTag_getAttribute('listviewname', $attribs, $lvname, we_base_request::STRING);
	$src = weTag_getAttribute('src', $attribs, '', we_base_request::STRING);
	$target = weTag_getAttribute('target', $attribs, '', we_base_request::STRING);

	$attribs['title'] = weTag_getAttribute('title', $attribs, '', we_base_request::STRING);
	$attribs['format'] = weTag_getAttribute('format', $attribs, '', we_base_request::STRING);
	$attribs['class'] = weTag_getAttribute('class', $attribs);
	$attribs['classid'] = weTag_getAttribute('classid', $attribs, 0, we_base_request::INT);
	$attribs['seeMode'] = weTag_getAttribute('seeMode', $attribs, true, we_base_request::BOOL);
	$attribs['customerid'] = weTag_getAttribute('customerid', $attribs, 0, we_base_request::INT);
	$attribs['country'] = weTag_getAttribute('country', $attribs, '', we_base_request::STRING);
	//zusatz typen für verchiedene field-Typen
	$attribs['thumbnail'] = weTag_getAttribute('thumbnail', $attribs, '', we_base_request::STRING);
	$attribs['thumbnailid'] = weTag_getAttribute('thumbnailid', $attribs, 0, we_base_request::INT);
// Image
	$attribs['classes'] = weTag_getAttribute('classes', $attribs, '', we_base_request::STRING);
	//Wwysiwyg
	$attribs['commands'] = weTag_getAttribute('commands', $attribs, '', we_base_request::STRING);
	//Wwysiwyg
	$attribs['fontnames'] = weTag_getAttribute('fontnames', $attribs, '', we_base_request::STRING);

	$attribs['href'] = $href;
	$attribs['type'] = $type;
	$attribs['alt'] = $alt;
	$attribs['tid'] = $tid;
	$attribs['id'] = $id;
	$attribs['xml'] = $xml;
	$attribs['only'] = $only;
	$attribs['usekey'] = $usekey;
	$attribs['triggerid'] = $triggerid;
	$attribs['showpath'] = $showpath;
	$attribs['rootdir'] = $rootdir;
	$attribs['value'] = $value;
	$attribs['target'] = $target;
	$attribs['src'] = $src;
	$attribs['field'] = $field;
	unset($attribs['winprops']);

	$out = '';

	$alt = (strtolower($alt) === strtolower(we_listview_base::PATH_FIELD) ? we_listview_base::PATH_FIELD : (strtolower($alt) === strtolower(we_listview_base::TEXT_FIELD) ? we_listview_base::TEXT_FIELD : $alt));
	$name = (strtolower($orgName) === strtolower(we_listview_base::PATH_FIELD) ? we_listview_base::PATH_FIELD : (strtolower($orgName) === strtolower(we_listview_base::TEXT_FIELD) ? we_listview_base::TEXT_FIELD : $name));

	//listview of documents, document with a block. Try to access by blockname.
	$name = ($GLOBALS['lv']->f($name) ? $name : $orgName);

	$classid = (!empty($GLOBALS['lv']) ? (
		($GLOBALS['lv'] instanceof we_listview_objectBase) ?
		$GLOBALS['lv']->f(we_listview_base::CLASS_FIELD) :
		($GLOBALS['lv'] instanceof we_listview_shopItems ?
		$GLOBALS['lv']->f(we_listview_base::PROPPREFIX . 'tableid') :
		''
		)
		) : //Fix #9223
		(isset($GLOBALS['we_doc']->OF_ID) ?
		$GLOBALS['we_doc']->TableID :
		0
		)
		);

	$isImageDoc = ($GLOBALS['lv']->f(we_listview_base::CONTENTTYPE_FIELD) == we_base_ContentTypes::IMAGE);
	$cal = $GLOBALS['lv']->getCalendarStruct();
	$isCalendar = (!empty($cal['calendar']) && $GLOBALS['lv']->isCalendarField($type));

	if((!$GLOBALS['lv']->f(we_listview_base::ID_FIELD) && empty($cal['calendar']))){
		return '';
	}


	switch($type){
		case 'binary' :
			$t = $GLOBALS['we_doc']->getFieldByVal($GLOBALS['lv']->f($name), $type, $attribs, false, $GLOBALS['we_doc']->ParentID, $GLOBALS['we_doc']->Path, $GLOBALS['DB_WE'], $classid, 'listview');
			switch($only){
				case '':
				case 'name':
					$out = $t[0];
					break;
				case 'path':
					$out = $t[1];
					break;
				case 'parentpath':
					$out = $t[2];
					break;
				case 'filename':
					$out = $t[3];
					break;
				case 'extension':
					$out = $t[4];
					break;
				case 'filesize':
					$out = $t[5];
					break;
			}
			$href = ($href ?: $t[1]);
			break;
		case 'link' :
			if(!empty($GLOBALS['lv'])){
				$out = $GLOBALS['we_doc']->getFieldByVal($GLOBALS['lv']->f($name), 'link', $attribs, false, $GLOBALS['we_doc']->ParentID, $GLOBALS['we_doc']->Path, $GLOBALS['DB_WE'], $classid, 'listview');
				$href = ($href ?: $out);
				break;
			}
		case 'img' :
			if($src){

				$imgAtts = removeEmptyAttribs(
					array_merge([
					'alt' => '', //  alt must be set
					'src' => $src,
					'xml' => $xml,
						], useAttribs($attribs, ['alt', 'width', 'height', 'border', 'hspace', 'align', 'vspace'])), ['alt']); //  use some atts form attribs array

				$out = getHtmlTag('img', $imgAtts);
				if(!$out){
					//we have no image, so we don't generate an link
					return '';
				}
				break;
			}
		//intentionally no break
		case 'int' :
		case 'date' :
		case 'float' :
		case 'checkbox' :
		case 'collection':
			$idd = ($isImageDoc && $type === 'img' ) ? $GLOBALS['lv']->f(we_listview_base::ID_FIELD) : $GLOBALS['lv']->f($name);
			$out = ($idd == 0 ? '' : $GLOBALS['we_doc']->getFieldByVal($idd, $type, $attribs, false, $GLOBALS['we_doc']->ParentID, $GLOBALS['we_doc']->Path, $GLOBALS['DB_WE'], $classid, 'listview'));
			if($type === 'img' && empty($out)){
				return '';
			}
			break;
		case 'day' :
		case 'dayname' :
		case 'dayname_long' :
		case 'dayname_short' :
		case 'month' :
		case 'monthname' :
		case 'monthname_long' :
		case 'monthname_short' :
		case 'year' :
		case 'hour' :
		case 'week' :
			list(, $langcode) = getFieldOutLang($attribs);
			$cal = $GLOBALS['lv']->getCalendarStruct();
			$out = $GLOBALS['lv']->getCalendarField($type, $langcode);
			break;

		case 'multiobject':
			$temp = we_unserialize($GLOBALS['lv']->f($name));
			$out = is_array($temp) ? (!empty($temp['objects']) ? implode(',', $temp['objects']) : implode(',', $temp)) : '';
			break;
		case 'country' :
			list(, $langcode) = getFieldOutLang($attribs);
			$out = (WE_COUNTRIES_DEFAULT != '' && $GLOBALS['lv']->f($name) === '--' ?
				WE_COUNTRIES_DEFAULT :
				CheckAndConvertISOfrontend(we_base_country::getTranslation($GLOBALS['lv']->f($name), we_base_country::TERRITORY, $langcode))
				);
			break;
		case 'language' :
			list(, $langcode) = getFieldOutLang($attribs);
			$out = CheckAndConvertISOfrontend(we_base_country::getTranslation($GLOBALS['lv']->f($name), we_base_country::LANGUAGE, $langcode));
			break;
		case 'shopVat' :
			if(we_modules_info::isActive(we_modules_info::SHOP)){
				if(!we_shop_category::isCategoryMode()){
					$normVal = $GLOBALS['we_doc']->getFieldByVal($GLOBALS['lv']->f(we_shop_shop::VAT_FIELD_NAME), $type, $attribs, false, $GLOBALS['we_doc']->ParentID, $GLOBALS['we_doc']->Path, $GLOBALS['DB_WE'], $classid, 'listview'); // war '$GLOBALS['lv']->getElement', getElemet gibt es aber nicht in LVs, gefunden bei #4648
					$out = we_shop_vats::getVatRateForSite($normVal);
				} else {
					$shopVatAttribs = array_merge($attribs, [
						'shopcategoryid' => $GLOBALS['lv']->f(we_shop_shop::CATEGORY_FIELD_NAME),
						'wedoccategories' => $GLOBALS['lv']->f(we_listview_base::CATEGORY_FIELD)
					]);
					unset($shopVatAttribs['type']);

					$out = we_tag('shopVat', $shopVatAttribs);
				}
			}
			break;
		case 'shopCategory' :
			if(we_modules_info::isActive(we_modules_info::SHOP) && !empty($GLOBALS['lv'])){
				$id = $GLOBALS['lv']->f(we_shop_shop::CATEGORY_FIELD_NAME);
				$wedocCategory = $GLOBALS['lv']->f(we_listview_base::CATEGORY_FIELD);

				$out = we_shop_category::getShopCatFieldByID($id, $wedocCategory, $field, $showpath, $rootdir, true);
			}
			break;
		case 'href' ://#6329: fixed for lv type=document. check later for other types! #6421: field type=href in we:block
			if(!empty($GLOBALS['lv'])){
				switch(true){
					case ($GLOBALS['lv'] instanceof we_listview_document):
						$hrefArr = [
							'int' => $GLOBALS['lv']->f($name . we_base_link::MAGIC_INT_LINK) ?: $GLOBALS['lv']->f(we_tag_getPostName($name) . we_base_link::MAGIC_INT_LINK),
							'intID' => $GLOBALS['lv']->f($name . we_base_link::MAGIC_INT_LINK_ID) ?: $GLOBALS['lv']->f(we_tag_getPostName($name) . we_base_link::MAGIC_INT_LINK_ID),
							'extPath' => $GLOBALS['lv']->f($name)
						];
						break;
					case ($GLOBALS['lv'] instanceof we_listview_objectBase):
					case ($GLOBALS['lv'] instanceof we_listview_shopOrderitem): //Fix #7816
						$hrefArr = we_unserialize($GLOBALS['lv']->f($name));
						if(!is_array($hrefArr)){
							$hrefArr = [];
						}
						break;
				}
				$out = $hrefArr ? we_document::getHrefByArray($hrefArr) : '';
				$path_parts = pathinfo($out);
				if(!empty($GLOBALS['lv']->hidedirindex) && seoIndexHide($path_parts['basename'])){
					$out = ($path_parts['dirname'] != '/' ? $path_parts['dirname'] : '') . '/';
				}

				break;
			}
		default : // FIXME: treat type="select" as separate case, and clean up the mess with all this little fixes

			if($orgName === we_listview_base::PATH_FIELD && $triggerid && in_array(get_class($GLOBALS['lv']), ['we_listview_search', 'we_listview_object', 'we_listview_multiobject'])){
				$triggerpath = id_to_path($triggerid);
				$triggerpath_parts = pathinfo($triggerpath);
				$normVal = ($triggerpath_parts['dirname'] != '/' ? $triggerpath_parts['dirname'] : '') . '/' .
					(!empty($GLOBALS['lv']->hidedirindex) && seoIndexHide($triggerpath_parts['basename']) ?
					'' : $triggerpath_parts['filename'] . '/' ) .
					$GLOBALS['lv']->f(we_listview_base::URL_FIELD);
			} else {
				$testtype = ($type === 'select' && $usekey) ? 'text' : $type;
				switch(true){
					case ($GLOBALS['lv'] instanceof we_listview_objectBase):
						if($type === 'select'){// bugfix #6399
							$attribs['name'] = $attribs['_name_orig'];
						}
					default:
						$normVal = $GLOBALS['we_doc']->getFieldByVal($GLOBALS['lv']->f($name), $testtype, $attribs, false, $GLOBALS['we_doc']->ParentID, $GLOBALS['we_doc']->Path, $GLOBALS['DB_WE'], $classid, 'listview');
						$normVal = we_wysiwyg_editor::parseGalleryTags($normVal);

						if($orgName === we_listview_base::PATH_FIELD){
							$path_parts = pathinfo($normVal);
							if(!$GLOBALS['WE_MAIN_DOC']->InWebEdition && !empty($GLOBALS['lv']->hidedirindex) && seoIndexHide($path_parts['basename'])){
								$normVal = ($path_parts['dirname'] != '/' ? $path_parts['dirname'] : '') . '/';
							}
						}
				}
			}
			// bugfix 7557
			// wenn die Abfrage im Aktuellen Objekt kein Ergebnis liefert
			// wird in den eingebundenen Objekten ueberprueft ob das Feld existiert

			if($type === 'select' && $normVal === ''){
				//FIXME: remove getDBRecord
				$dbRecord = array_keys($GLOBALS['lv']->getDBRecord()); // bugfix #6399
				foreach($dbRecord as $glob_key){
					if(substr($glob_key, 0, 7) === we_object::QUERY_PREFIX){
						$normVal = $GLOBALS['we_doc']->getFieldByVal($GLOBALS['lv']->f($name), ($usekey ? 'text' : 'select'), $attribs, false, $GLOBALS['we_doc']->ParentID, $GLOBALS['we_doc']->Path, $GLOBALS['DB_WE'], substr($glob_key, 7), 'listview'); // war '$GLOBALS['lv']->getElement', getElemet gibt es aber nicht in LVs, gefunden bei #4648
					}

					if($normVal != ''){
						break;
					}
				}
			}
			// EOF bugfix 7557


			if($name && $name != 'we_href'){
				if($normVal === ''){
					$altVal = $GLOBALS['we_doc']->getFieldByVal($GLOBALS['lv']->f($alt), $type, $attribs, false, $GLOBALS['we_doc']->ParentID, $GLOBALS['we_doc']->Path, $GLOBALS['DB_WE'], $classid, 'listview');
					if($altVal === ''){
						return '';
					}

					if($alt === we_listview_base::PATH_FIELD){
						$path_parts = pathinfo($altVal);
						if(!empty($GLOBALS['lv']->hidedirindex) && seoIndexHide($path_parts['basename'])){
							$altVal = ($path_parts['dirname'] != '/' ? $path_parts['dirname'] : '') . '/';
						}
					}
					$normVal = $altVal;
				}
				$out = cutText(($striphtml ? strip_tags($normVal) : $normVal), $max, $striphtml);
			} elseif($value){
				$out = ($striphtml ? strip_tags($value) : $value);
			} else if($striphtml){
				$out = strip_tags($out);
			}
	}

	if($hyperlink || $name === 'we_href'){
		$linkAttribs = useAttribs($attribs, ['xml', 'class', 'style']);
		if($target){ //  save atts in array
			$linkAttribs['target'] = $target;
		}

		foreach($attribs as $key => $val){
			if(strpos($key, 'pass_') === 0){
				$linkAttribs[$key] = $val;
			}
		}

		if($href){
			$linkAttribs['href'] = $href;
			return getHtmlTag('a', $linkAttribs, $out, true);
		}

		if($id && $isCalendar){
			$cal = $GLOBALS['lv']->getCalendarStruct();
			if(!empty($cal['storage'])){

				foreach($cal['storage'] as $date){
					if((($cal['calendarCount'] > 0 || ($cal['calendar'] === 'day' && $cal['calendarCount'] >= 0)) && $cal['calendarCount'] <= $cal['numofentries']) && ((int) $date >= (int) $cal['start_date'] && (int) $date <= (int) $cal['end_date'])){
						$show = ($cal['calendar'] === 'year' ? 'month' : 'day');
						$linkAttribs['href'] = id_to_path($id) . '?' . http_build_query(array_merge(
									$GLOBALS['lv']->getListviewRequest($listviewname), array_filter([
								'we_lv_calendar_' . $listviewname => $show,
								'we_lv_datefield_' . $listviewname => $cal['datefield'],
								'we_lv_date_' . $listviewname => ($cal['date'] >= 0 ? date('Y-m-d', $cal['date']) : '')
						])));

						return getHtmlTag('a', $linkAttribs, $out, true);
					}
				}
			}
		} elseif($id && $isImageDoc){
			$linkAttribs['href'] = id_to_path($id) . '?' . http_build_query(array_merge(
						$GLOBALS['lv']->getListviewRequest($listviewname), [
					'we_lv_start_' . $lvname => (($GLOBALS['lv']->count + $GLOBALS['lv']->start) - 1),
					'we_lv_pend_' . $lvname => ($GLOBALS['lv']->start + $GLOBALS['lv']->anz),
					'we_lv_pstart_' . $lvname => ($GLOBALS['lv']->start)
			]));

			return getHtmlTag('a', $linkAttribs, $out, true);
		}

		if($tid){
			$GLOBALS['lv']->tid = $tid;
		}

		if(($GLOBALS['lv'] instanceof we_listview_search) && $GLOBALS['lv']->f('ClassID')){
			$tail = ($tid ? '&amp;we_objectTID=' . $tid : '');

			$path_parts = pathinfo(getScriptName());
			$isSeo = $GLOBALS['lv']->objectseourls;
			if($isSeo){
				$h = getHash('SELECT  Url,TriggerID FROM ' . OBJECT_FILES_TABLE . ' WHERE ID=' . intval($GLOBALS['lv']->f('OID')));
				$objecttriggerid = $h['TriggerID'];
				$objecturl = $h['Url'] . '?';
				if($objecttriggerid){
					$path_parts = pathinfo(id_to_path($objecttriggerid));
				}
			} else {
				$objecturl = '?we_objectID=' . $GLOBALS['lv']->f('OID') . '&';
			}

			$pidstr = '?pid=' . intval($GLOBALS['lv']->f('WorkspaceID'));
			$linkAttribs['href'] = (!empty($GLOBALS['lv']->hidedirindex) && seoIndexHide($path_parts['basename']) ?
				($path_parts['dirname'] != '/' ? $path_parts['dirname'] : '') . '/' .
				$objecturl .
				$pidstr :
				($isSeo && $objecturl ?
				($path_parts['dirname'] != '/' ? $path_parts['dirname'] : '') . '/' . $path_parts['filename'] . '/' . $objecturl :
				getScriptName() . $objecturl
				) . $pidstr);

			$linkAttribs['href'] .= $tail;

			return ($name === 'we_href' ?
				$linkAttribs['href'] :
				getHtmlTag('a', $linkAttribs, $out, true) //  output of link-tag
				);
		}
		if(($GLOBALS['lv'] instanceof we_listview_category) && we_tag('ifHasChildren')){
			$linkAttribs['href'] = getScriptName() . '?' . $parentidname . '=' . $GLOBALS['lv']->f('ID');

			return ($name === 'we_href' ?
				$linkAttribs['href'] :
				getHtmlTag('a', $linkAttribs, $out, true) //  output of link-tag
				);
		}
		$showlink = false;
		switch(get_class($GLOBALS['lv'])){
			case 'we_listview_document':
				$triggerid = $triggerid ?: $GLOBALS['lv']->triggerID;
				$tailOwnId = '?we_documentID=' . $GLOBALS['lv']->f(we_listview_base::ID_FIELD);
			case '':
			case 'we_listview_search':
			case 'we_listview_variants':
			case 'we_listview_shopItems':
			case 'we_customertag':
			case 'we_listview_customer':
				$showlink = true;
				break;
			case 'we_listview_object':
				$triggerid = $triggerid ?: $GLOBALS['lv']->triggerID;
				$showlink = $tid || $triggerid || $GLOBALS['lv']->f(we_listview_base::PROPPREFIX . 'templates') || $GLOBALS['lv']->docID;
				$tailOwnId = '?we_objectID=' . $GLOBALS['lv']->f('OF_ID');
				break;
			case 'we_listview_multiobject':
				$showlink = $GLOBALS['lv']->f(we_listview_base::PROPPREFIX . 'templates') || $GLOBALS['lv']->docID;
				break;
			case 'we_listview_shopOrder': //listview type="order"
				$showlink = !empty($triggerid);
				break;
			default:
				$showlink = false;
				break;
		}

		if(!$showlink){
			return $out;
		}

		$tail = ($tid && ($GLOBALS['lv'] instanceof we_listview_object) ? '&amp;we_objectTID=' . $tid : '');

		if(isset($GLOBALS['we_doc']->OF_ID) && ($GLOBALS['we_doc']->InWebEdition)){
			$linkAttribs['href'] = $GLOBALS['lv']->f(we_listview_base::LASTPATH_FIELD) . $tail;
		} else {
			$path_parts = pathinfo($GLOBALS['lv']->f(we_listview_base::PATH_FIELD));
			if($triggerid){
				$triggerpath = id_to_path($triggerid);
				$triggerpath_parts = pathinfo($triggerpath);

				$linkAttribs['href'] = (!empty($GLOBALS['lv']->objectseourls)) ? // objectseourls=true
					(empty($triggerpath_parts['dirname']) ? '' : rtrim($triggerpath_parts['dirname'], '/') ) . '/' .
					((!$GLOBALS['WE_MAIN_DOC']->InWebEdition && !empty($GLOBALS['lv']->hidedirindex) && seoIndexHide($triggerpath_parts['basename'])) ? //hidedirindex of triggerID
					$GLOBALS['lv']->f(we_listview_base::URL_FIELD) . $tail : //Fix #8708 do not hidedirindex of triggerID
					$triggerpath_parts['filename'] . '/' . $GLOBALS['lv']->f(we_listview_base::URL_FIELD) . $tail
					) : //objectseourls=false or not set
					$triggerpath . $tailOwnId . $tail;

				/* End Fix '7771 */
			} else {
				$linkAttribs['href'] = (!empty($GLOBALS['lv']->hidedirindex) && seoIndexHide($path_parts['basename']) ?
					($path_parts['dirname'] != '/' ? $path_parts['dirname'] : '') . '/' :
					$GLOBALS['lv']->f(we_listview_base::PATH_FIELD) . $tail
					);
			}
		}

		return ($name === 'we_href' ? //  return href for this object
			$linkAttribs['href'] :
			getHtmlTag('a', $linkAttribs, $out, true));
	}

	return $out;
}
