<?php

/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
function we_tag_ifClient(array $attribs){
	$br = we_base_browserDetect::inst();

	if(($browser = weTag_getAttribute('browser', $attribs, '', we_base_request::STRING))){
		$bro = explode(',', $browser);
		$browserOfClient = $br->getBrowser();
		$browserMatched = in_array($browserOfClient, $bro);
		// for backwards compatibility
		if(!$browserMatched){
			$browserMatched = ((we_base_browserDetect::isNN() && in_array('mozilla', $bro)) ||
				($browserOfClient == we_base_browserDetect::APPLE && in_array('safari', $bro)));
		}
		if(!$browserMatched){
			return false;
		}
	} else {
		$browserMatched = true;
	}

	if(($version = weTag_getAttribute('version', $attribs, '', we_base_request::FLOAT))){
		$brv = $br->getBrowserVersion();
		switch(weTag_getAttribute('operator', $attribs, '', we_base_request::STRING)){
			case 'equal':
				$versionMatched = (floor(floatval($brv)) == floor($version));
				break;
			case 'less':
				$versionMatched = (floatval($brv) < $version);
				break;
			case 'less|equal':
				$versionMatched = (floatval($brv) <= $version);
				break;
			case 'greater':
				$versionMatched = (floatval($brv) > $version);
				break;
			case 'greater|equal':
				$versionMatched = (floatval($brv) >= $version);
				break;
			default://old behaviour
				//FIXME: remove in 7.2
				t_e('deprecated', 'call of ifClient with deprecated syntax');
				$versionMatched = true;
				$ver = str_replace(['up', 'down', 'eq'], ['>=', '<', '=='], $version);

				if(strpos($ver, '==') !== false){
					eval('$versionMatched=(' . floor(floatval($brv)) . $ver . ');');
				} else {
					eval('$versionMatched=(' . floatval($brv) . $ver . ');');
				}
				break;
		}
		if(!$versionMatched){
			return false;
		}
	} else {
		$versionMatched = true;
	}

	$system = weTag_getAttribute('system', $attribs, '', we_base_request::STRING);

	$systemMatched = ($system && $browserMatched && $versionMatched ? in_array($br->getSystem(), explode(',', $system)) : true);

	return $browserMatched && $versionMatched && $systemMatched;
}
